module Net (module Net) where

import ST
import TransSystem
import Relation
import MMonad


--- definition of net


class (Cpo s) => State s where
    splus , sminus :: s -> [s] -> [s]

class  (Cpo t) => Transition t

class  (State s, Transition t) => Net n s t where
    fwrd, bwrd ::   n s t -> t -> [s]

instance (State s, Transition t, Eq s, Spanned t, Net n s t) => TransSystem n s t  where
    transition k =  delta . tr where
       tr t s = s `sminus` (fwrd k t) `ifIs` (bot .<.) >>= (`splus` (bwrd k t)) `ifIs` (.<. top)
--
    trans_set  k = range 								  

